package slidingwindow;

import java.util.HashSet;

/**
 * 题目：3.无重复字符的最长子串 (lengthOfLongestSubstring)
 * 描述：给定一个字符串 s ，请你找出其中不含有重复字符的 最长 子串 的长度。
 * 链接：https://leetcode.cn/problems/longest-substring-without-repeating-characters/
 *
 示例 1:
 输入: s = "abcabcbb"
 输出: 3
 解释: 因为无重复字符的最长子串是 "abc"，所以其长度为 3。

 示例 2:
 输入: s = "bbbbb"
 输出: 1
 解释: 因为无重复字符的最长子串是 "b"，所以其长度为 1。
 示例 3:
 输入: s = "pwwkew"
 输出: 3
 解释: 因为无重复字符的最长子串是 "wke"，所以其长度为 3。
 请注意，你的答案必须是 子串 的长度，"pwke" 是一个子序列，不是子串。
 */
//二刷会做
public class LengthOfLongestSubstring {
    public int lengthOfLongestSubstring(String s) {
        int left=0,right=0,max_length=0;
        HashSet<Character> set=new HashSet<>();
        while (left<=right && right<s.length()){
            char temp=s.charAt(right);
            if(!set.contains(temp)){
                set.add(temp);
                if((right-left+1)>max_length){
                    max_length=right-left+1;
                }
                right+=1;
            }
            else {
                set.remove(s.charAt(left));
                left+=1;
            }
        }
        return max_length;
    }
}
