package hash;

import java.util.HashMap;
import java.util.HashSet;

/**
 * 题目：128.最长连续序列 (longestConsecutive)
 * 描述：给定一个未排序的整数数组 nums ，找出数字连续的最长序列（不要求序列元素在原数组中连续）的长度。
 * 请你设计并实现时间复杂度为 O(n) 的算法解决此问题。
 * 链接：https://leetcode.cn/problems/longest-consecutive-sequence/
 *
 示例 1：
 输入：nums = [100,4,200,1,3,2]
 输出：4
 解释：最长数字连续序列是 [1, 2, 3, 4]。它的长度为 4。

 示例 2：
 输入：nums = [0,3,7,2,5,8,4,6,0,1]
 输出：9

 示例 3：
 输入：nums = [1,0,1,2]
 输出：3
 */
//没做出来
//二刷会做
public class LongestConsecutive {
    public int longestConsecutive(int[] nums) {
        // 将数组中的所有元素存入 HashSet
        HashSet<Integer> set = new HashSet<>();
        for (int num : nums) {
            set.add(num);
        }
        int longestStreak = 0;

        // 遍历数组中的每个元素
        for (int num : set) {
            // 如果当前元素是连续序列的起点（即没有前驱元素）
            if (!set.contains(num - 1)) {
                int currentNum = num;
                int currentStreak = 1;

                // 计算以当前元素为起点的连续序列的长度
                while (set.contains(currentNum + 1)) {
                    currentNum++;
                    currentStreak++;
                }

                // 更新最长连续序列的长度
                longestStreak = Math.max(longestStreak, currentStreak);
            }
        }

        return longestStreak;
    }
}
